package org.jboss.security.auth.spi;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.jboss.logging.Logger;
import org.jboss.security.auth.spi.Users;
import org.jboss.xb.binding.ObjectModelFactory;
import org.jboss.xb.binding.UnmarshallingContext;
import org.xml.sax.Attributes;

public class UsersObjectModelFactory implements ObjectModelFactory {
  private static Logger log = Logger.getLogger(org.jboss.security.auth.spi.UsersObjectModelFactory.class);
  
  public Object completeRoot(Object root, UnmarshallingContext ctx, String uri, String name) {
    return root;
  }
  
  public Object newRoot(Object root, UnmarshallingContext navigator, String namespaceURI, String localName, Attributes attrs) {
    if (!localName.equals("users"))
      throw new IllegalStateException("Unexpected root element: was expecting 'users' but got '" + localName + "'"); 
    log.trace("newRoot, root=" + root);
    return new Users();
  }
  
  public void setValue(Users users, UnmarshallingContext navigator, String namespaceUri, String localName, String value) {}
  
  public Object newChild(Users users, UnmarshallingContext navigator, String namespaceUri, String localName, Attributes attrs) {
    Users.User child = null;
    if ("user".equals(localName)) {
      String name = attrs.getValue("name");
      child = new Users.User(name);
      String password = attrs.getValue("password");
      child.setPassword(password);
      String encoding = attrs.getValue("encoding");
      child.setEncoding(encoding);
      log.trace("newChild, user=" + child);
    } 
    return child;
  }
  
  public void addChild(Users users, Users.User user, UnmarshallingContext navigator, String namespaceURI, String localName) {
    users.addUser(user);
  }
  
  public Object newChild(Users.User user, UnmarshallingContext navigator, String namespaceUri, String localName, Attributes attrs) {
    String[] roleInfo = { null, "Roles" };
    if ("role".equals(localName)) {
      roleInfo[0] = attrs.getValue("name");
      roleInfo[1] = attrs.getValue("group");
      if (roleInfo[1] == null)
        roleInfo[1] = "Roles"; 
    } 
    return roleInfo;
  }
  
  public void addChild(Users.User user, String[] roleInfo, UnmarshallingContext navigator, String namespaceURI, String localName) {
    user.addRole(roleInfo[0], roleInfo[1]);
  }
}
